/*******************************************************************
*
*                       Cinepak for SATURN Player 
*                                by SOJ
*                         usage sample program
*
*		t@CVXegĂbc̃[rt@CĐTv
*                       [rt@C "SAMPLE.CPK"
*
*                      Copyright(c) 1994,1995 SEGA
*
*   Comment: main module
*   File   : SMPCPK4.c
*   Date   : 1994-10-31
*   Author : H.G
*
*******************************************************************/
/* 񈳏k摜̃[r[Đ */
/* #define NONE_COMPRESS_VIDEO */

/*  WORK RAM H ɓWJAVRAMDMA] */
#define OUTPUT_WORK_RAM

/* VlpbNCuɃX[ubotg킹B */
/* #define DUAL_CPU */

/* ĐJngKTCY̐ݒs */
/*#define START_TRG_SIZE		 (RING_BUF_SIZ - 24*2048) */
#define START_TRG_SIZE		 (30 * 2048)

#include <machine.h>
#include <string.h>
#define _SH
#include "sega_xpt.h"
#include "sega_sys.h"
#include "sega_def.h"
#include "sega_mth.h"
#include "sega_scl.h" 
#include "sega_int.h"
#define  _SPR2_
#include "sega_spr.h"
#include "sega_cdc.h"
#include "sega_gfs.h"
#include "sega_dma.h"
#include "sega_per.h"
#include "sega_snd.h"
#include "sega_cpk.h"



static void smpVblIn(void);
static void smpVblOut(void);
static void smpSprEnd(void);


/*------------------------- s}N萔t -------------------------*/

/* XvCgʂ̂uq`l̃AhX */
#define ADDR_VDP1 				(0x25C00000)

/* uq`l̓]̃AhX */
#define ADDR_VRAM_CPK 			(0x25C08000)
#define ADDR_VRAM_MON 			(0x25C30000)

/* EF[uq`l̓]AhXƃTv */
#define	PCM_ADDR				((void*)0x25a20000)
#define	PCM_SIZE				(4096L*16)

#define	RING_BUF_SIZ	(1024L*200)

/* suʂ̃TCY */
#define   DISP_XSIZE       320
#define   DISP_YSIZE       224

/* XvCg֘A */
#define SPRITE_CPK		(3)
#define LUX_CPK			(0)
#define LUY_CPK			(0)
#define DX_CPK			(320)
#define DY_CPK			(224)

/* Đ郀[r̐ */
#define	FILE_NUM		(2)

/* {[̍ŏlCől */
#define LEVEL_MIN		(0)
#define LEVEL_MAX		(7)

/* p̍ŏlCőlCl */
#define PAN_MIN			(0)					/* [F͍őAE̓[ */
#define PAN_MAX			(31)				/* E[FE͍őA̓[ */
#define PAN_CENTER		((PAN_MAX + 1) / 2)	/* FAEő 	*/


/*----------------------- sO[oϐt -----------------------*/

/* [Nobt@ */
static Uint32 g_movie_work[CPK_15WORK_DSIZE];

/* Oobt@ */
static Uint32 g_movie_buf[RING_BUF_SIZ / sizeof(Uint32)];

/* Đ郀[rt@C */
static char *filename = "SAMPLE.CPK";

/* XvCg`ItO   TRUE : `I */
static volatile Bool g_spr_end;

/* o͂郏[Ñobt@ */
#ifdef OUTPUT_WORK_RAM
	Uint32 work_ram_buf[320L * 256L / 2];
	Uint32 cp_size;
#endif

/* pbh */
static Uint32	PadWorkArea[7];
static Uint16	PadData1  = 0x0000;
static Uint16	PadData1E = 0x0000;
static Uint16	PadData2  = 0x0000;
static Uint16	PadData2E = 0x0000;

/* |[Y̏ */
static Bool		g_pause_at_once;
static Bool		g_pause_keyframe;

/* {[̒l */
Sint32 g_level = LEVEL_MAX;

/* p̒lFE 0..31 ŕ\l */
Sint32 g_pan = PAN_CENTER;

/* p̒lFɎw肷l */
Sint32 g_pan_tbl[PAN_MAX + 1] = {
	0x1f, 0x1e, 0x1d, 0x1c, 0x1b, 0x1a, 0x19, 0x18, 
	0x17, 0x16, 0x15, 0x14, 0x13, 0x12, 0x11, 0x10, 
	0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 
	0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f
};

/********************************************************************/
/* G[ɌĂ΂֐									*/
/********************************************************************/
void errGfsFunc(void *obj, Sint32 ec)
{
	/* G[ */
}

void errCpkFunc(void *obj, Sint32 ec)
{
	/* G[ */
}


/* t[obt@̐؂ւƁA`I҂ */
void smp_WaitDisplayFrame(void)
{
	/* uq`lt[obt@ւ(O)`I҂ */
	while (g_spr_end == FALSE) ;

	/* t[obt@̐؂ւ */
	SCL_DisplayFrame();

	g_spr_end = FALSE;
}
void smp_DisplayFrameWait(void)
{
	/* t[obt@̐؂ւ */
	SCL_DisplayFrame();

	g_spr_end = FALSE;

	/* uq`lt[obt@ւ(O)`I҂ */
	while (g_spr_end == FALSE) ;

}


/*====================== ʕ\̏ ===========================*/
#define CHARADDR(addr)		((Uint16)(((addr) >> 3) & 0x0000ffff))
#define CHARSIZE(dx, dy)	((Uint16)((((dx) >> 3)<<8) | (dy)))

static SprSpCmd SpriteCmd[] = {
	{
		/* control  */ (JUMP_NEXT | FUNC_SCLIP),
		/* link     */  0,
		/* drawMode */  0,
		/* color    */  0,
		/* charAddr */  0,
		/* charSize */  0,
		/* ax, ay   */  0, 0,
		/* bx, by   */  0, 0,
		/* cx, cy   */  351, 223,
		/* dx, dy   */  0, 0,
		/* grshAddr */  0,
		/* dummy    */  0
	}, {
		/* control  */ (JUMP_NEXT | FUNC_LCOORD),
		/* link     */  0,
		/* drawMode */  0,
		/* color    */  0,
		/* charAddr */  0,
		/* charSize */  0,
		/* ax, ay   */  0, 0,
		/* bx, by   */  0, 0,
		/* cx, cy   */  0, 0,
		/* dx, dy   */  0, 0,
		/* grshAddr */  0,
		/* dummy    */  0
	}, {
		/* control  */ (JUMP_NEXT | FUNC_UCLIP),
		/* link     */  0,
		/* drawMode */  0,
		/* color    */  0,
		/* charAddr */  0,
		/* charSize */  0,
		/* ax, ay   */  0, 0,
		/* bx, by   */  0, 0,
		/* cx, cy   */  351, 223,
		/* dx, dy   */  0, 0,
		/* grshAddr */  0,
		/* dummy    */  0
	}, {
		/* control  */  (JUMP_NEXT | FUNC_DISTORSP),
		/* link     */  0,
		/* drawMode */  0x04A8,
		/* color    */  0x0000,		/*  */
		/* charAddr */  CHARADDR(ADDR_VRAM_CPK),
		/* charSize */  CHARSIZE(DX_CPK, DY_CPK),
		/* ax, ay   */  LUX_CPK, 				LUY_CPK,
		/* bx, by   */  LUX_CPK + DX_CPK - 1, 	LUY_CPK,
		/* cx, cy   */  LUX_CPK + DX_CPK - 1, 	LUY_CPK + DY_CPK - 1,
		/* dx, dy   */  LUX_CPK, 				LUY_CPK + DY_CPK - 1,
		/* grshAddr */  0,
		/* dummy    */  0
	}, {
		/* [ 0]     */
		/* control  */ 	(CTRL_END),
		/* link     */ 	0,
		/* drawMode */ 	0,
		/* color    */ 	0,
		/* charAddr */ 	0,
		/* charSize */ 	0,
		/* ax, ay   */  0,   0,
		/* bx, by   */  0,   0,
		/* cx, cy   */  0,   0,
		/* dx, dy   */  0,   0,
		/* rshAddr */   0,
		/* dummy    */  0
	}
};

void eraseVram(void)
{
	Sint32 *addr = (Sint32 *)(0x25C80000);	/* end of VDP1 VRAM */

	do {
		*--addr = 0x80008000;
	} while ((Sint32)addr > 0x25C00000);	/* start of VDP1 VRAM */
}

static void dispInit(void)
{
    Uint8  *VRAM;
	Uint16			BackCol;

    set_imask(0);
    SCL_Vdp2Init();
    SCL_SetPriority(SCL_SP0|SCL_SP1|SCL_SP2|SCL_SP3|
                    SCL_SP4|SCL_SP5|SCL_SP6|SCL_SP7,7);
    SCL_SetSpriteMode(SCL_TYPE1,SCL_MIX,SCL_SP_WINDOW);

	/* uuN̐ݒ */
	INT_ChgMsk(INT_MSK_NULL,INT_MSK_VBLK_IN | INT_MSK_VBLK_OUT);

	/* V_Blank Out 荞݂҂ */
	(*((volatile Uint32 *)0x25fe00a4)) &= 0xfffffffc;	/* ܂NA */
	while( !((*((volatile Uint32 *)0x25fe00a4)) & 2) );
	PER_Init(PER_KD_PERTIM,2,PER_ID_DGT,PER_SIZE_DGT,PadWorkArea,0);

	INT_SetScuFunc(INT_SCU_VBLK_IN, smpVblIn);
	INT_SetScuFunc(INT_SCU_VBLK_OUT, smpVblOut);
	INT_ChgMsk(INT_MSK_VBLK_IN | INT_MSK_VBLK_OUT,INT_MSK_NULL);

	/* XvCg`I荞݂̐ݒ */
	INT_ChgMsk(INT_MSK_NULL,INT_MSK_SPR);
	INT_SetScuFunc(INT_SCU_SPR, smpSprEnd);
	INT_ChgMsk(INT_MSK_SPR, INT_MSK_NULL);

	BackCol = 0x0000;
	SCL_SetBack(SCL_VDP2_VRAM+0x80000-2,1,&BackCol);

    SPR_Initial(&VRAM);
    SPR_SetEraseData(RGB16_COLOR(0,0,0),0,0,DISP_XSIZE-1,DISP_YSIZE-1);
	SCL_SetFrameInterval(1);
	SCL_DisplayFrame();
	SCL_DisplayFrame();
	SCL_SetFrameInterval(-1);

	eraseVram();
}

static void setSprite(Sint32 sizeX, Sint32 sizeY)
{
	Uint32 		luX, luY, rdX, rdY;

	SpriteCmd[SPRITE_CPK].charSize = CHARSIZE(sizeX, sizeY);
	luX = (320 - sizeX) / 2;
	luY = (224 - sizeY) / 2;
	rdX = luX + sizeX - 1;
	rdY = luY + sizeY - 1;
	SpriteCmd[SPRITE_CPK].ax = luX;
	SpriteCmd[SPRITE_CPK].ay = luY;
	SpriteCmd[SPRITE_CPK].bx = rdX;
	SpriteCmd[SPRITE_CPK].by = luY;
	SpriteCmd[SPRITE_CPK].cx = rdX;
	SpriteCmd[SPRITE_CPK].cy = rdY;
	SpriteCmd[SPRITE_CPK].dx = luX;
	SpriteCmd[SPRITE_CPK].dy = rdY;

	memcpy((void *)ADDR_VDP1, SpriteCmd, sizeof(SpriteCmd));
}


/*====================== uuN̏ ===========================*/
static void smpVblIn(void)
{
	/* b VblIn [`R[ */
	CPK_VblIn();

	/* OtBbNCugpׂɂ͎sȂ΂ȂȂ */
	SCL_VblankStart();

}

static void smpVblOut(void)
{
	PerDgtInfo	*pad;

	PER_GetPer((PerGetPer **)&pad);
	PadData1  = pad[0].data ^ 0xffff;
	PadData1E |= pad[0].push ^ 0xffff;
	PadData2  = pad[1].data ^ 0xffff;
	PadData2E |= pad[1].push ^ 0xffff;

	/* OtBbNCugpׂɂ͎sȂ΂ȂȂ */
	SCL_VblankEnd();
}

static void smpSprEnd(void)
{
	g_spr_end = TRUE;
}

/*====================== TEh̏ ===========================*/
#define SDDRVS_TSK_SIZE			(0x6000)
#define BOOTSND_MAP_SIZE		(0x0100)
Sint32 sddrvs_tsk[SDDRVS_TSK_SIZE / 4];
Sint32 bootsnd_map[BOOTSND_MAP_SIZE / 4];

static Sint32 fileLoad(Sint8 *name, void *addr, Sint32 bsize)
{
	Sint32 		fid, i;

	for (i = 0; i < 10; i++) {
		fid = GFS_NameToId(name);
		if (fid >= 0) {
			GFS_Load(fid, 0, addr, bsize);
			return 0;
		}
	}
	return -1;
}

static void sndInit(void)
{
	SndIniDt 	snd_init;

	if (fileLoad("SDDRVS.TSK", (void *)sddrvs_tsk, SDDRVS_TSK_SIZE)) {
		return;
	}
	if (fileLoad("BOOTSND.MAP", (void *)bootsnd_map, BOOTSND_MAP_SIZE)) {
		return;
	}
	SND_INI_PRG_ADR(snd_init) 	= (Uint16 *)sddrvs_tsk;
	SND_INI_PRG_SZ(snd_init) 	= (Uint16 )SDDRVS_TSK_SIZE;
	SND_INI_ARA_ADR(snd_init) 	= (Uint16 *)bootsnd_map;
	SND_INI_ARA_SZ(snd_init) 	= (Uint16)BOOTSND_MAP_SIZE;
	SND_Init(&snd_init);
	SND_ChgMap(0);
}


/*====================== t@C̏ ===========================*/
/* [gfBNgɂt@C̍ő吔 */
#define MAX_DIR		100

/* ɊJt@C̍ő吔 */
#define OPEN_MAX	5

/* fBNgǗ̈ */
static GfsDirTbl	dir_tbl;

/* t@C܂񂾏 */
static GfsDirName dir_name[MAX_DIR];

/* fer̍Ɨ̈ */
static Uint8 gfs_work[GFS_WORK_SIZE(OPEN_MAX)];


static void fileInit(void)
{
	Sint32 file_num;

	/* GFS̏ */
	GFS_DIRTBL_TYPE(&dir_tbl) = GFS_DIR_NAME;
	GFS_DIRTBL_DIRNAME(&dir_tbl) = dir_name;
	GFS_DIRTBL_NDIR(&dir_tbl) = MAX_DIR;

	/* t@CVXȅ */
	file_num = GFS_Init(OPEN_MAX, gfs_work, &dir_tbl);
	if (file_num < 0) {
		return;
	}

	/* G[֐̐ݒ */
	GFS_SetErrFunc(errGfsFunc, NULL);
}

static GfsHn fileOpen(char *fname)
{
    Sint32 fid;

    /* t@Ct@Cʎq߂ */
    fid = GFS_NameToId(fname);
    return GFS_Open(fid);
}

static void fileClose(GfsHn fp)
{
	GFS_Close(fp);
}


/* VlpbN̏ */
void cpkInit(void)
{
	/* VlpbN̏ */
	CPK_Init();

	/* G[֐̐ݒ */
	CPK_SetErrFunc(errCpkFunc, NULL);

#ifdef DUAL_CPU
	/* VlpbNCuɃX[ubotg킹 */
	CPK_SetCpu(CPK_CPU_DUAL);
#endif
}

/* [rnh */
static CpkHn createMovie(GfsHn gfs)
{
	Uint32 			movie_x, movie_y;
	CpkCreatePara	para;
	CpkHeader		*header;
	CpkHn			cpk;

	/* [rnh */
	CPK_PARA_WORK_ADDR(&para) = g_movie_work;
	CPK_PARA_WORK_SIZE(&para) = CPK_15WORK_BSIZE;
	CPK_PARA_BUF_ADDR(&para) = g_movie_buf;
	CPK_PARA_BUF_SIZE(&para) = RING_BUF_SIZ;
	CPK_PARA_PCM_ADDR(&para) = PCM_ADDR;
	CPK_PARA_PCM_SIZE(&para) = PCM_SIZE;
	cpk = CPK_CreateGfsMovie(&para, gfs);
	if (cpk == NULL) {
		return NULL;
	}

	/* \FRQOOOFɐݒ */
	CPK_SetColor(cpk, CPK_COLOR_15BIT);

	/* wb_ǂݍ */
	/* [r̃TCY\߂킩Ăꍇ CPK_Preload  */
	/* CPK_GetHeader ͌ĂԕKvȂ */
	/* CPK_PreloadHeader() Ă΂ȂĐ̊Jn኱Ȃ */
	CPK_PreloadHeader(cpk);

	/* [r̃TCY擾 */
	header = CPK_GetHeader(cpk);
	movie_x = header->width;
	movie_y = header->height;
	setSprite(movie_x, movie_y);

	/* [r̓WJAhXݒ */
#ifdef OUTPUT_WORK_RAM
	CPK_SetDecodeAddr(cpk, (void *)work_ram_buf, 2 * movie_x);
	cp_size = (Uint32)(movie_x * movie_y * 2);
#else
	CPK_SetDecodeAddr(cpk, (void *)ADDR_VRAM_CPK, 2 * movie_x);
#endif

#ifdef START_TRG_SIZE
	/* ĐJngKTCY̐ݒ [byte] */
	CPK_SetStartTrgSize(cpk, START_TRG_SIZE);
#endif

	CPK_SetVolume(cpk, g_level);
	CPK_SetPan(cpk, g_pan_tbl[g_pan]);

	return cpk;
}

void smp_PadCtrlCpk(CpkHn cpk, Uint16 PadData1EW, Uint16 PadData1W)
{
	/* |[Y */
	if (PadData1EW & PER_DGT_S) {
		PadData1EW = 0;
		if (g_pause_at_once == FALSE) {
			/* Jn */

			/* CPK_PAUSE_ON_AT_ONCE ͏d̂ŁAsOɊmɐÎ~摜				 * \ĂB
			 * ȂƁA|[YuԂɃJNbƂꍇB
			 */
			/* t[obt@̐؂ւƁA`I҂ */
			smp_DisplayFrameWait();

			g_pause_at_once = TRUE;
			CPK_Pause(cpk, CPK_PAUSE_ON_AT_ONCE);
		} else {
			/*  */
			g_pause_at_once = FALSE;
			CPK_Pause(cpk, CPK_PAUSE_OFF);
		}
	}
	if (PadData1EW & PER_DGT_C) {
		PadData1EW = 0;
		if (g_pause_keyframe == FALSE) {
			/* Jn */
			g_pause_keyframe = TRUE;
			CPK_Pause(cpk, CPK_PAUSE_ON_KEYFRAME);
		} else {
			/*  */
			g_pause_keyframe = FALSE;
			CPK_Pause(cpk, CPK_PAUSE_OFF);
		}
	}

	/* Xgbv */
	if (PadData1EW & PER_DGT_A) {
		PadData1EW = 0;
		CPK_Stop(cpk);
	}

#if 0
	/* `FW */
	if ((g_change_flag == FALSE) && (PadData1EW & PER_DGT_A)) {
		PadData1EW = 0;
		g_change_flag = TRUE;
		goNextStm(stm[1]);
	}
	/* [r̋؂ւ */
	if (g_change_flag == TRUE) {
		if (CPK_CheckChange() == CPK_CHANGE_OK_AT_ONCE) {
			CPK_Change();
			g_change_flag = FALSE;
		}
	}
#endif

	/* {[EAbv */
	if (PadData1EW & PER_DGT_U) {
		PadData1EW = 0;
		g_level = MIN(g_level + 1, LEVEL_MAX);
		CPK_SetVolume(cpk, g_level);
	}
	/* {[E_E */
	if (PadData1EW & PER_DGT_D) {
		PadData1EW = 0;
		g_level = MAX(g_level - 1, LEVEL_MIN);
		CPK_SetVolume(cpk, g_level);
	}

	/* pEEiEőAXɎキj */
	if (PadData1EW & PER_DGT_R) {
		PadData1EW = 0;
		g_pan = MIN(g_pan + 1, PAN_MAX);
		CPK_SetPan(cpk, g_pan_tbl[g_pan]);
	}
	/* pEiőAEXɎキj */
	if (PadData1EW & PER_DGT_L) {
		PadData1EW = 0;
		g_pan = MAX(g_pan - 1, PAN_MIN);
		CPK_SetPan(cpk, g_pan_tbl[g_pan]);
	}
}

#define SMP_PAD_MODE_NUM		(1)
Sint32 smp_pad_mode = 0;

/* pbh */
void smp_PadCtrl(CpkHn cpk)
{
	Uint16   PadData1EW;
	Uint16   PadData1W;

	PadData1EW = PadData1E;
	PadData1E = 0;
	PadData1W = PadData1;
	PadData1 = 0;

	/* pbhΏۂ̐؂ւ */
	if (PadData1EW & PER_DGT_TL) {
		PadData1EW = 0;
		smp_pad_mode++;
	}

	switch (smp_pad_mode % SMP_PAD_MODE_NUM) {
	case 0:
		/* pbhFĐCu */
		smp_PadCtrlCpk(cpk, PadData1EW, PadData1W);
		break;
	}
}

void main(void)
{
	CpkHn 			cpk;
	GfsHn			gfs;
	Uint32			restart;

#ifdef OUTPUT_WORK_RAM
	DMA_ScuInit();
#endif

	/* ϐ̏ */
	g_spr_end = TRUE;

	/* XvCg̐ݒ */
	dispInit();

	/* t@C */
	fileInit();

	/* TEh̐ݒ */
	sndInit();

	/* VlpbN̏ */
	cpkInit();

	restart = 1;

	while (1) {
		if (restart) {

			/* t@CI[v */
			if ((gfs = fileOpen(filename)) == NULL) {
				return;
			}

			/* [rnh */
			cpk = createMovie(gfs);

			/* [rJn */
			CPK_Start(cpk);

			restart = 0;
		}

		/* [r̍Đ */
		CPK_Task(cpk);

		/* ʕ\ṽ`FbN */
		if (CPK_IsDispTime(cpk) == TRUE) {

#ifdef OUTPUT_WORK_RAM
			DMA_ScuMemCopy((void *)ADDR_VRAM_CPK, 
				(void *)work_ram_buf, cp_size);
#endif

			/* t[obt@̐؂ւƁA`I҂ */
			smp_DisplayFrameWait();

			/* \̒ʒm */
			CPK_CompleteDisp(cpk);
		} else {

			/* t[obt@̐؂ւƁA`I҂ */
			smp_DisplayFrameWait();
		}

		/* pbh */
		smp_PadCtrl(cpk);

		/* [ȑI */
		if (CPK_GetPlayStatus(cpk) == CPK_STAT_PLAY_END) {

			/* ŏIt[\邽߂̑҂ */
			/* t[obt@̐؂ւ҂ */
			SCL_DisplayFrame();

			/* [r̕ */
			CPK_DestroyGfsMovie(cpk);

			/* t@C̃N[Y*/
			fileClose(gfs);

			restart = 1;
		}
	}
}
