/*******************************************************************
*
*                       Cinepak for SATURN Player 
*                                by SOJ
*                         usage sample program
*
*           ɂ郀[rt@C̎wt[摜WJ
*           WJt[摜͐擪Ō܂œWJ,
*           Ōォ擪֓WJB
*           [rt@C 0x4000000 ԒnɃ[hĂ
*           gpł郀[r̃t@CTCY͂PUla܂ŁB
*
*                      Copyright(c) 1994,1995 SEGA
*
*   Comment: main module
*   File   : SMPCPK7.c
*   Date   : 1994-10-31
*   Author : Y.T
*
*******************************************************************/
#include <machine.h>
#include <string.h>
#define _SH
#include "sega_xpt.h"
#include "sega_sys.h"
#include "sega_def.h"
#include "sega_mth.h"
#include "sega_scl.h" 
#include "sega_int.h"
#define  _SPR2_
#include "sega_spr.h"
#include "sega_cpk.h"
#include "sega_dma.h"

static void hintProc(void);
static void smpVblIn(void);
static void smpVblOut(void);


/*------------------------- s}N萔t -------------------------*/

/* XvCgʂ̂uq`l̃AhX */
#define ADDR_VDP1 			(0x25C00000)

/* uq`l̓]̃AhX */
#define ADDR_VRAM 			((void *)0x25C08000)

/* EF[uq`l̓]AhXƃTv */
#define PCM_ADDR			((void*)0x25a20000)
#define PCM_SIZE			(4096L*16)

/* [Nobt@̃TCY */
#define WORK_BUF_SIZ		(1024L*1024L*16)

/* suʃTCY */
#define DISP_XSIZE			(320)
#define DISP_YSIZE			(224)


/*----------------------- sO[oϐt -----------------------*/

/* [Nobt@ */
static Uint32 g_movie_work[CPK_24WORK_DSIZE];

/* Oobt@ */
static Uint32 *g_movie_buf = (Uint32 *)0x04000000;

/* 摜WJobt@ */
static Uint32 g_decode_buf[DISP_XSIZE * DISP_YSIZE];

/* [r̃TCY */
static Uint32 movie_x, movie_y;

/* Tv */
static Sint32 g_sample_total;

/* guNJE^ */
static volatile long	g_hint_cnt;

/* TCNp^[ */
static Uint16	cycle_tbl[]={
	0x4444,0x4444,
	0xffff,0xffff,
	0x4444,0x4444,
	0xffff,0xffff
};

static volatile Sint32 g_vint_cnt;

/*---------------------------- s֐t ----------------------------*/

/********************************************************************/
/* G[ɌĂ΂֐									*/
/********************************************************************/
void errCpkFunc(void *obj, Sint32 errcode)
{
	/* G[ */
}

/*====================== ʕ\̏ ===========================*/
static void memsetDword(Uint32 *dst, Uint32 value, Sint32 cnt)
{
	dst	+= cnt;
	while (--cnt >= 0) {
		*--dst = value;
	}
}

static void dispSclInit(void)
{
	SclVramConfig	tp;
	SclConfig		scfg;
	int				i;
	Uint16			BackCol;

	memsetDword((Uint32 *)SCL_VDP2_VRAM_A, 0x80000000, 512L * 512L/2);

   /*******************************************
    *	ucoQ̏                      *
    *******************************************/
	SCL_Vdp2Init();

	/* V-Blank荞݃[`̓o^ */
	INT_ChgMsk(INT_MSK_NULL,INT_MSK_VBLK_IN | INT_MSK_VBLK_OUT);
	INT_SetScuFunc(INT_SCU_VBLK_IN, smpVblIn);
	INT_SetScuFunc(INT_SCU_VBLK_OUT, smpVblOut);
	INT_ChgMsk(INT_MSK_VBLK_IN | INT_MSK_VBLK_OUT,INT_MSK_NULL);

	/* guN̐ݒ */
	INT_ChgMsk(INT_MSK_NULL, INT_MSK_HBLK_IN);
	INT_SetScuFunc(INT_SCU_HBLK_IN, hintProc);
	INT_ChgMsk(INT_MSK_HBLK_IN, INT_MSK_NULL);

	SCL_SetFrameInterval(1);
	set_imask(0);

   /*******************************************
    *	۰ٺ̨ڰ݂̐ݒ                *
    *******************************************/
	SCL_InitConfigTb(&scfg);
	scfg.dispenbl  = ON;
	scfg.platesize = SCL_PL_SIZE_1X1;
	scfg.bmpsize   = SCL_BMP_SIZE_512X256;
	scfg.coltype   = SCL_COL_TYPE_1M;
	scfg.datatype  = SCL_BITMAP;
	scfg.mapover   = SCL_OVER_2;
	for(i=0;i<16;i++)
		scfg.plate_addr[i] = SCL_VDP2_VRAM_A;
	SCL_SetConfig(SCL_NBG0, &scfg);

   /*******************************************
    *	ײèݒ(0`7)                  *
    *******************************************/
	SCL_SetPriority(SCL_SPR,0);
	SCL_SetPriority(SCL_NBG0,7);

	/* TCNp^[̐ݒ */
    SCL_SetCycleTable(cycle_tbl);

   /*******************************************
    *	obNʂ̐Fɐݒ              *
    *******************************************/
	BackCol = 0x0000;
	SCL_SetBack(SCL_VDP2_VRAM+0x80000-2,1,&BackCol);

	SCL_Open(SCL_NBG0);
		SCL_MoveTo(FIXED(0), FIXED(0),0);/* Home Position */
		SCL_Scale(FIXED(1.0), FIXED(1.0));
		SCL_SetRotateViewPoint(160,112,500);
		SCL_SetRotateCenter(160,112,0);
	SCL_Close();
	SCL_DisplayFrame();

}

static void hintProc(void)
{
	g_hint_cnt++;

}

/* VRAMTCNp^[ioN`OjWX^ */
#define		CYCLE_A_REG		0x25f80010

/* VRAMTCNp^[ioNaOjWX^ */
#define		CYCLE_B_REG		0x25f80018

/* bot[h^Cg[hɂ */
#define		CYCLE_CPU_WRITE(reg_addr)	\
	{ \
	*((Uint16 *)(reg_addr)) = 0xeeee; \
	*((Uint16 *)(reg_addr)+1) = 0xeeee; \
	}

/* LN^p^[f[^[h[hɂ */
#define		CYCLE_VDP_READ(reg_addr) \
	{ \
	*((Uint16 *)(reg_addr)) = 0x4444; \
	*((Uint16 *)(reg_addr)+1) = 0x4444; \
	}


void copyDma(Uint32 *vram_addr)
{
	register int		y;
	register Uint32	*src, *dst;

	/* 㔼̓] */
	while (g_hint_cnt != (DISP_YSIZE/2 + 2)) ;

	/* oN`ObotCg[hɂ */
	CYCLE_CPU_WRITE(CYCLE_A_REG);

	src = g_decode_buf;
	dst = vram_addr;
	for (y = 0; y < movie_y/2; y++) {
		DMA_ScuMemCopy(dst, src, movie_x * 4);
		while (DMA_ScuResult() == DMA_SCU_BUSY) ;
		src += movie_x;
		dst += SCL_MAXLINE;
	}
	/* oN`OLN^p^[f[^[hɂ */
	CYCLE_VDP_READ(CYCLE_A_REG);

	/* ̓] */
	while (g_hint_cnt >= DISP_YSIZE/2) ;

	/* oNaObotCg[hɂ */
	CYCLE_CPU_WRITE(CYCLE_B_REG);

	for ( ; y < movie_y; y++) {
		DMA_ScuMemCopy(dst, src, movie_x * 4);
		while (DMA_ScuResult() == DMA_SCU_BUSY) ;
		src += movie_x;
		dst += SCL_MAXLINE;
	}
	/* oNaOLN^p^[f[^[hɂ */
	CYCLE_VDP_READ(CYCLE_B_REG);
}


/*====================== uuN̏ ===========================*/
static void smpVblIn(void)
{
	/* b VblIn [`R[ */
	CPK_VblIn();

	/* OtBbNCugpׂɂ͎sȂ΂ȂȂ */
	SCL_VblankStart();
	g_hint_cnt = 0;
	g_vint_cnt++;
}

static void smpVblOut(void)
{
	/* OtBbNCugpׂɂ͎sȂ΂ȂȂ */
	SCL_VblankEnd();
	g_hint_cnt = 0;
}

/* VlpbN̏ */
void cpkInit(void)
{
	/* VlpbN̏ */
	CPK_Init();

	/* G[֐̐ݒ */
	CPK_SetErrFunc(errCpkFunc, NULL);
}

/* [rnh */
static CpkHn createMovie(void)
{
	CpkCreatePara	para;
	CpkHeader		*header;
	CpkHn			cpk;

	/* [rnh */
	CPK_PARA_WORK_ADDR(&para) = g_movie_work;
	CPK_PARA_WORK_SIZE(&para) = CPK_24WORK_BSIZE;
	CPK_PARA_BUF_ADDR(&para) = g_movie_buf;
	CPK_PARA_BUF_SIZE(&para) = WORK_BUF_SIZ;
	CPK_PARA_PCM_ADDR(&para) = PCM_ADDR;
	CPK_PARA_PCM_SIZE(&para) = PCM_SIZE;
	cpk = CPK_CreateMemMovie(&para);
	if (cpk == NULL) {
		return;
	}
	/* \FPUOOFɐݒ */
	CPK_SetColor(cpk, CPK_COLOR_24BIT);

	/* ̃[r̃t@CTCYݒ */
	CPK_NotifyWriteSize(cpk, WORK_BUF_SIZ);

	/* [r̃TCY擾 */
	header = CPK_GetHeader(cpk);
	movie_x = header->width;
	movie_y = header->height;

	/* Tv擾 */
	g_sample_total = header->sample_total;

	/* [r̕\AhXݒ */
	CPK_SetDecodeAddr(cpk, g_decode_buf, 4 * movie_x);

	return cpk;
}

/* EGCg */
/*
#define WAIT_TIME		(60 * 2)
#define WAIT_TIME		(0)
*/
#define WAIT_TIME		(60 / 4)

void waitVbl(Sint32 wait_time)
{
	Sint32		vint_old = g_vint_cnt;

	while (g_vint_cnt - vint_old < wait_time) {
		;
	}
}

void main(void)
{
	CpkHn 			cpk;
	Uint32			movie_lx, movie_ly;
	Sint32 			frame_no;
	int				i;
	Uint32			*vram_addr;

	/* ϐ̏ */
	g_vint_cnt = 0;

	/* XN[̐ݒ */
	dispSclInit();

	/* cl`̏ */
	DMA_ScuInit();

	/* VlpbN̏ */
	cpkInit();

	/* [rnh */
	cpk = createMovie();

	/* \ʒǔvZ */
	movie_lx = (DISP_XSIZE - movie_x)/2;
	movie_ly = (DISP_YSIZE - movie_y)/2;
	vram_addr = (Uint32 *)(SCL_VDP2_VRAM + 
				4 * (SCL_MAXLINE * movie_ly + movie_lx)
				+ 4 * SCL_MAXLINE * (SCL_MAXLINE/2 - DISP_YSIZE) / 2);

	/* ʃXN[ */
	SCL_Open(SCL_NBG0);
	SCL_MoveTo(FIXED(0), FIXED((SCL_MAXLINE/2 - DISP_YSIZE) / 2),0);
	SCL_Close();
	SCL_DisplayFrame();

	while (1) {
		for (frame_no = 0; frame_no < g_sample_total; frame_no++) {
			/* wԍ̃t[WJ */
			CPK_DecodeFrame(cpk, frame_no);

			/* 摜] */
			copyDma(vram_addr);

			waitVbl(WAIT_TIME);
		}
		frame_no--;
		for (; frame_no >= 0; frame_no--) {
			/* wԍ̃t[WJ */
			CPK_DecodeFrame(cpk, frame_no);

			/* 摜] */
			copyDma(vram_addr);

			waitVbl(WAIT_TIME);
		}
	}
}
