/*******************************************************************
 *
 *                       Cinepak for SATURN Player 
 *                                by SOJ
 *                         usage sample program
 *
 *@@@@@Xg[VXegĂbc̃[rt@C
 *@@@@@X[YɘAĐTv
 *          [rt@C "SAMPLE01.CPK""SAMPLE02.CPK"
 *          bc SAMPLE01.CPK,SAMPLE02.CPK ̏ɔzu邱ƁB
 *
 *                      Copyright(c) 1994,1995 SEGA
 *
 *   Comment: main module
 *   File   : SMPCPK5.C
 *   Date   : 1994-10-31
 *   Author : H.G
 *
 * pbh@F
 *@[`]
 *		Õt@CĐɂ`{^ƁAIɌ㔼̃t@C
 *		؂ւčĐJn܂B
 *		`{^Ȃ΁AÕt@C̏IX[YɌ㔼̃t@
 *		C̍ĐJn܂B
 *		㔼̃t@CĐɂ`{^ƁÃt@C̍Đ𒆒f
 * 		Aŏɖ߂܂B
 *	[b]
 *		 xڂ̓L[t[|[YAxƃ|[YB
 *	[START]
 *		 xڂ̓|[YAxƃ|[YB
 *	[UP], [DOWN]
 *		{[̐ݒBO`VBl͂VB
 *	[LEFT], [RIGHT]
 *		p̐ݒBĺAAEőB
 *		p̐ݒ́Am̍Đ̏ꍇLłB
 *******************************************************************/

/*  WORK RAM H ɓWJAVRAMDMA] */
#define OUTPUT_WORK_RAM

/* VlpbNCuɃX[ubotg킹B */
/* #define DUAL_CPU */

/* ĐJngKTCY̐ݒs */
/*#define START_TRG_SIZE		 (RING_BUF_SIZ - 24*2048) */
#define START_TRG_SIZE		 (30 * 2048)

#include <machine.h>
#include <string.h>
#define _SH
#include "sega_xpt.h"
#include "sega_sys.h"
#include "sega_def.h"
#include "sega_mth.h"
#include "sega_scl.h" 
#include "sega_int.h"
#define  _SPR2_
#include "sega_spr.h"
#include "sega_dma.h"
#include "sega_per.h"
#include "sega_cdc.h"
#include "sega_gfs.h"
#include "sega_stm.h"
#include "sega_snd.h"
#include "sega_cpk.h"

static void smpVblIn(void);
static void smpVblOut(void);
static void smpSprEnd(void);


/*------------------------- s}N萔t -------------------------*/

/* XvCgʂ̂uq`l̃AhX */
#define ADDR_VDP1		(0x25C00000)

/* uq`l̓]̃AhX */
#define ADDR_VRAM_CPK	(0x25C08000)

/* EF[uq`l̓]AhXƃTv */
#define	PCM_ADDR		((void*)0x25a20000)
#define	PCM_SIZE		(4096L*16)

/* Oobt@̃TCY */
#ifdef NONE_COMPRESS_VIDEO
	#define	RING_BUF_SIZ	(1024L*300)
#else
	#define	RING_BUF_SIZ	(1024L*200)
#endif

/* suʂ̃TCY */
#define DISP_XSIZE		(320)
#define DISP_YSIZE		(224)

/* Đ郀[r̐ */
#define	FILE_NUM		(2)

/* {[̍ŏlCől */
#define LEVEL_MIN		(0)
#define LEVEL_MAX		(7)

/* p̍ŏlCőlCl */
#define PAN_MIN			(0)					/* [F͍őAE̓[ */
#define PAN_MAX			(31)				/* E[FE͍őA̓[ */
#define PAN_CENTER		((PAN_MAX + 1) / 2)	/* FAEő 	*/

/* sbNAbvړ̔}[W [ZN^] */
#define MOVE_PICKUP_MARGIN		(20)

/*----------------------- sO[oϐt -----------------------*/

/* [Nobt@ */
static Uint32 g_movie_work[FILE_NUM][CPK_15WORK_DSIZE];

/* Oobt@ */
static Uint32 g_movie_buf[FILE_NUM][RING_BUF_SIZ / sizeof(Uint32)];

/* Đ郀[rt@C */
static char *filename[] = {"SAMPLE01.CPK", "SAMPLE02.CPK"};
/* static char *filename[] = {"F1_A.CPK", "F1_B.CPK"}; */

/* XvCg`ItO   TRUE : `I */
static volatile Bool g_spr_end;

/* o͂郏[Ñobt@ */
#ifdef OUTPUT_WORK_RAM
	Uint32 work_ram_buf[320L * 256L / 2];
	Uint32 cp_size;
#endif

/* pbh */
static Uint32	PadWorkArea[7];
static	Uint16	PadData1  = 0x0000;
static	Uint16	PadData1E = 0x0000;
static	Uint16	PadData2  = 0x0000;
static	Uint16	PadData2E = 0x0000;

/* |[Y̏ */
static Bool		g_pause_at_once;
static Bool		g_pause_keyframe;

/* {[̒l */
Sint32 g_level = LEVEL_MAX;

/* p̒lFE 0..31 ŕ\l */
Sint32 g_pan = PAN_CENTER;

/* p̒lFɎw肷l */
Sint32 g_pan_tbl[PAN_MAX + 1] = {
	0x1f, 0x1e, 0x1d, 0x1c, 0x1b, 0x1a, 0x19, 0x18, 
	0x17, 0x16, 0x15, 0x14, 0x13, 0x12, 0x11, 0x10, 
	0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 
	0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f
};

/* [r̋؂ւtO */
static Bool		g_change_flag;


/*---------------------------- s֐t ----------------------------*/

/********************************************************************/
/* G[ɌĂ΂֐									*/
/********************************************************************/
void errGfsFunc(void *obj, Sint32 ec)
{
	/* G[ */
}

void errStmFunc(void *obj, Sint32 ec)
{
	/* G[ */
}

void errCpkFunc(void *obj, Sint32 ec)
{
	/* G[ */
}

/* t[obt@̐؂ւƁA`I҂ */
void smp_WaitDisplayFrame(void)
{
	/* uq`lt[obt@ւ(O)`I҂ */
	while (g_spr_end == FALSE) ;

	/* t[obt@̐؂ւ */
	SCL_DisplayFrame();

	g_spr_end = FALSE;
}
void smp_DisplayFrameWait(void)
{
	/* t[obt@̐؂ւ */
	SCL_DisplayFrame();

	g_spr_end = FALSE;

	/* uq`lt[obt@ւ(O)`I҂ */
	while (g_spr_end == FALSE) ;

}


/*====================== ʕ\̏ ===========================*/
#define HENKEI_SPRITE		(3)

static SprSpCmd SpriteCmd[] = {
	{
		/* control  */ (JUMP_NEXT | FUNC_SCLIP),
		/* link     */  0,
		/* drawMode */  0,
		/* color    */  0,
		/* charAddr */  0,
		/* charSize */  0,
		/* ax, ay   */  0, 0,
		/* bx, by   */  0, 0,
		/* cx, cy   */  351, 223,
		/* dx, dy   */  0, 0,
		/* grshAddr */  0,
		/* dummy    */  0
	}, {
		/* control  */ (JUMP_NEXT | FUNC_LCOORD),
		/* link     */  0,
		/* drawMode */  0,
		/* color    */  0,
		/* charAddr */  0,
		/* charSize */  0,
		/* ax, ay   */  0, 0,
		/* bx, by   */  0, 0,
		/* cx, cy   */  0, 0,
		/* dx, dy   */  0, 0,
		/* grshAddr */  0,
		/* dummy    */  0
	}, {
		/* control  */ (JUMP_NEXT | FUNC_UCLIP),
		/* link     */  0,
		/* drawMode */  0,
		/* color    */  0,
		/* charAddr */  0,
		/* charSize */  0,
		/* ax, ay   */  0, 0,
		/* bx, by   */  0, 0,
		/* cx, cy   */  351, 223,
		/* dx, dy   */  0, 0,
		/* grshAddr */  0,
		/* dummy    */  0
	}, {
		/* control  */  (JUMP_NEXT | FUNC_DISTORSP),
		/* link     */  0,
		/* drawMode */  0x04A8,
		/* color    */  0x0000,		/*  */
		/* charAddr */  0x1000,
		/* charSize */  0x2098,
		/* ax, ay   */  0x0020,         0x0020,
		/* bx, by   */  0x0020 + 255,   0x0020,
		/* cx, cy   */  0x0020 + 255,   0x0020 + 151,
		/* dx, dy   */  0x0020,         0x0020 + 151,
		/* grshAddr */  0,
		/* dummy    */  0
	}, {
		/* [ 0]     */
		/* control  */ 	(CTRL_END),
		/* link     */ 	0,
		/* drawMode */ 	0,
		/* color    */ 	0,
		/* charAddr */ 	0,
		/* charSize */ 	0,
		/* ax, ay   */  0,   0,
		/* bx, by   */  0,   0,
		/* cx, cy   */  0,   0,
		/* dx, dy   */  0,   0,
		/* rshAddr */   0,
		/* dummy    */  0
	}
};

void eraseVram(void)
{
	Sint32 *addr = (Sint32 *)(0x25C80000);	/* end of VDP1 VRAM */

	do {
		*--addr = 0x80008000;
	} while ((Sint32)addr > 0x25C00000);	/* start of VDP1 VRAM */
}

static void dispInit(void)
{
    Uint8  *VRAM;
	Uint16			BackCol;

    set_imask(0);
    SCL_Vdp2Init();
    SCL_SetPriority(SCL_SP0|SCL_SP1|SCL_SP2|SCL_SP3|
                    SCL_SP4|SCL_SP5|SCL_SP6|SCL_SP7,7);
    SCL_SetSpriteMode(SCL_TYPE1,SCL_MIX,SCL_SP_WINDOW);

	/* uuN̐ݒ */
	INT_ChgMsk(INT_MSK_NULL,INT_MSK_VBLK_IN | INT_MSK_VBLK_OUT);

	/* V_Blank Out 荞݂҂ */
	(*((volatile Uint32 *)0x25fe00a4)) &= 0xfffffffc;	/* ܂NA */
	while( !((*((volatile Uint32 *)0x25fe00a4)) & 2) );
	PER_Init(PER_KD_PERTIM,2,PER_ID_DGT,PER_SIZE_DGT,PadWorkArea,0);

	INT_SetScuFunc(INT_SCU_VBLK_IN, smpVblIn);
	INT_SetScuFunc(INT_SCU_VBLK_OUT, smpVblOut);
	INT_ChgMsk(INT_MSK_VBLK_IN | INT_MSK_VBLK_OUT,INT_MSK_NULL);

	/* XvCg`I荞݂̐ݒ */
	INT_ChgMsk(INT_MSK_NULL,INT_MSK_SPR);
	INT_SetScuFunc(INT_SCU_SPR, smpSprEnd);
	INT_ChgMsk(INT_MSK_SPR, INT_MSK_NULL);

	BackCol = 0x0000;
	SCL_SetBack(SCL_VDP2_VRAM+0x80000-2,1,&BackCol);

    SPR_Initial(&VRAM);
    SPR_SetEraseData(RGB16_COLOR(0,0,0),0,0,DISP_XSIZE-1,DISP_YSIZE-1);
	SCL_SetFrameInterval(1);
	SCL_DisplayFrame();
	SCL_DisplayFrame();
	SCL_SetFrameInterval(-1);

	eraseVram();
}


static void setSprite(Uint32 sizeX, Uint32 sizeY)
{
	Uint32 		luX, luY, rdX, rdY;

	SpriteCmd[HENKEI_SPRITE].charSize = (sizeX/8)<<8 | sizeY;
	luX = (320 - sizeX) / 2;
	luY = (224 - sizeY) / 2;
	rdX = luX + sizeX - 1;
	rdY = luY + sizeY - 1;
	SpriteCmd[HENKEI_SPRITE].ax = luX;
	SpriteCmd[HENKEI_SPRITE].ay = luY;
	SpriteCmd[HENKEI_SPRITE].bx = rdX;
	SpriteCmd[HENKEI_SPRITE].by = luY;
	SpriteCmd[HENKEI_SPRITE].cx = rdX;
	SpriteCmd[HENKEI_SPRITE].cy = rdY;
	SpriteCmd[HENKEI_SPRITE].dx = luX;
	SpriteCmd[HENKEI_SPRITE].dy = rdY;

	memcpy((void *)ADDR_VDP1, SpriteCmd, sizeof(SpriteCmd));
}


/*====================== uuN̏ ===========================*/
static void smpVblIn(void)
{
	/* b VblIn [`R[ */
	CPK_VblIn();

	/* OtBbNCugpׂɂ͎sȂ΂ȂȂ */
	SCL_VblankStart();

}

static void smpVblOut(void)
{
	PerDgtInfo	*pad;

	PER_GetPer((PerGetPer **)&pad);
	PadData1  = pad[0].data ^ 0xffff;
	PadData1E |= pad[0].push ^ 0xffff;
	PadData2  = pad[1].data ^ 0xffff;
	PadData2E |= pad[1].push ^ 0xffff;

	/* OtBbNCugpׂɂ͎sȂ΂ȂȂ */
	SCL_VblankEnd();
}


static void smpSprEnd(void)
{
	g_spr_end = TRUE;
}

/*====================== TEh̏ ===========================*/
#define SDDRVS_TSK_SIZE			(0x6000)
#define BOOTSND_MAP_SIZE		(0x0100)
Sint32 sddrvs_tsk[SDDRVS_TSK_SIZE / 4];
Sint32 bootsnd_map[BOOTSND_MAP_SIZE / 4];

static Sint32 fileLoad(Sint8 *name, void *addr, Sint32 bsize)
{
	Sint32 		fid, i;

	for (i = 0; i < 10; i++) {
		fid = GFS_NameToId(name);
		if (fid >= 0) {
			GFS_Load(fid, 0, addr, bsize);
			return 0;
		}
	}
	return -1;
}

static void sndInit(void)
{
	SndIniDt 	snd_init;

	if (fileLoad("SDDRVS.TSK", (void *)sddrvs_tsk, SDDRVS_TSK_SIZE)) {
		return;
	}
	if (fileLoad("BOOTSND.MAP", (void *)bootsnd_map, BOOTSND_MAP_SIZE)) {
		return;
	}
	SND_INI_PRG_ADR(snd_init) 	= (Uint16 *)sddrvs_tsk;
	SND_INI_PRG_SZ(snd_init) 	= (Uint16 )SDDRVS_TSK_SIZE;
	SND_INI_ARA_ADR(snd_init) 	= (Uint16 *)bootsnd_map;
	SND_INI_ARA_SZ(snd_init) 	= (Uint16)BOOTSND_MAP_SIZE;
	SND_Init(&snd_init);
	SND_ChgMap(0);
}


/*====================== t@C̏ ===========================*/

/* [gfBNgɂt@C̍ő吔 */
#define MAX_DIR		50

/* ɊJt@C̍ő吔 */
#define OPEN_MAX	FILE_NUM

/* Xg[O[v̂hc */
static StmGrpHn grp_hd;

/* fBNgǗ̈ */
static GfsDirTbl	dir_tbl;

/* t@C܂񂾏 */
static GfsDirName dir_name[MAX_DIR];

/* fer̍Ɨ̈ */
static Uint8 gfs_work[GFS_WORK_SIZE(OPEN_MAX)];

/* rsl̍Ɨ̈ */
static Uint8 stm_work[STM_WORK_SIZE(12, 24)];

static void fileInit(void)
{
	Sint32 file_num;

    /* t@CVXȅ */
	GFS_DIRTBL_TYPE(&dir_tbl) = GFS_DIR_NAME;
	GFS_DIRTBL_DIRNAME(&dir_tbl) = dir_name;
	GFS_DIRTBL_NDIR(&dir_tbl) = MAX_DIR;
    file_num = GFS_Init(OPEN_MAX, gfs_work, &dir_tbl);
	if (file_num < 0) {
		return;
	}

	/* Xg[VXȅ */
	STM_Init(12, 24, stm_work);

	/* G[֐̐ݒ */
	GFS_SetErrFunc(errGfsFunc, NULL);
	STM_SetErrFunc(errStmFunc, NULL);
}

static StmHn stmOpen(char *fname)
{
    Sint32 fid;
	StmKey key;
	StmHn  stm;

    /* t@Ct@Cʎq߂ */
    fid = GFS_NameToId(fname);
	STM_KEY_FN(&key) = STM_KEY_CN(&key) = STM_KEY_SMMSK(&key) = 
		STM_KEY_SMVAL(&key) = STM_KEY_CIMSK(&key) = STM_KEY_CIVAL(&key) =
		STM_KEY_NONE;
	stm = STM_OpenFid(grp_hd, fid, &key, STM_LOOP_NOREAD);
	return stm;
}

static void stmClose(StmHn fp)
{
	STM_Close(fp);
}


static void goNextStm(StmHn stm)
{
	Sint32		fad;
	Sint32		fid;
	StmFrange	frange;
	Sint32		bn;
	StmKey		stmkey;

	/* Xg[̍Đ͈͂擾 */
	STM_GetInfo(stm, &fid, &frange, &bn, &stmkey);

	/* Đ̂e`c̈ʒu擾 */
	STM_GetExecStat(grp_hd, &fad);
	
	if (fad + MOVE_PICKUP_MARGIN < STM_FRANGE_SFAD(&frange)) {
		/* sbNAbv̈ړ */
		STM_MovePickup(stm, 0);
	}
}

/* VlpbN̏ */
void cpkInit(void)
{
	/* VlpbN̏ */
	CPK_Init();

	/* G[֐̐ݒ */
	CPK_SetErrFunc(errCpkFunc, NULL);

#ifdef DUAL_CPU
	/* VlpbNCuɃX[ubotg킹 */
	CPK_SetCpu(CPK_CPU_DUAL);
#endif
}

/* [rnh */
static CpkHn createMovie(StmHn stm, int file_no)
{
	static Uint32 	movie_x, movie_y;
	CpkCreatePara	para;
	CpkHeader		*header;
	CpkHn			cpk;

	/* [r */
	CPK_PARA_WORK_ADDR(&para) = g_movie_work[file_no];
	CPK_PARA_WORK_SIZE(&para) = CPK_15WORK_BSIZE;
	CPK_PARA_BUF_ADDR(&para) = g_movie_buf[file_no];
	CPK_PARA_BUF_SIZE(&para) = RING_BUF_SIZ;
	CPK_PARA_PCM_ADDR(&para) = PCM_ADDR;
	CPK_PARA_PCM_SIZE(&para) = PCM_SIZE;
	cpk = CPK_CreateStmMovie(&para, stm);
	if (cpk == NULL) {
		return NULL;
	}

	/* \FRQOOOFɐݒ */
	CPK_SetColor(cpk, CPK_COLOR_15BIT);

	if (file_no == 0) {
		/* sbNAbv̈ړ */
		STM_MovePickup(stm, 0);

		/* wb_ǂݍ */
		CPK_PreloadHeader(cpk);

		/* [r̃TCY擾 */
		header = CPK_GetHeader(cpk);
		movie_x = header->width;
		movie_y = header->height;
		setSprite(movie_x, movie_y);
	}

	/* [r̓WJAhXݒ */
#ifdef OUTPUT_WORK_RAM
	CPK_SetDecodeAddr(cpk, (void *)work_ram_buf, 2 * movie_x);
	cp_size = (Uint32)(movie_x * movie_y * 2);
#else
	CPK_SetDecodeAddr(cpk, (void *)ADDR_VRAM_CPK, 2 * movie_x);
#endif

#ifdef START_TRG_SIZE
	/* ĐJngKTCY̐ݒ [byte] */
	CPK_SetStartTrgSize(cpk, START_TRG_SIZE);
#endif

	CPK_SetVolume(cpk, g_level);
	CPK_SetPan(cpk, g_pan_tbl[g_pan]);

	return cpk;
}

void smp_PadCtrlCpk(CpkHn cpk[], StmHn stm[], Uint16 PadData1EW, Uint16 PadData1W)
{
	Sint32 i;

	/* |[Y */
	if (PadData1EW & PER_DGT_S) {
		PadData1EW = 0;
		if (g_pause_at_once == FALSE) {
			/* Jn */

			/* CPK_PAUSE_ON_AT_ONCE ͏d̂ŁAsOɊmɐÎ~摜				 * \ĂB
			 * ȂƁA|[YuԂɃJNbƂꍇB
			 */
			/* t[obt@̐؂ւƁA`I҂ */
			smp_DisplayFrameWait();

			for (i = 0; i < FILE_NUM; i++) {
				if (CPK_Pause(cpk[i], CPK_PAUSE_ON_AT_ONCE) == TRUE) {
					g_pause_at_once = TRUE;
				}
			}
		} else {
			/*  */
			g_pause_at_once = FALSE;
			for (i = 0; i < FILE_NUM; i++) {
				CPK_Pause(cpk[i], CPK_PAUSE_OFF);
			}
		}
	}
	if (PadData1EW & PER_DGT_C) {
		PadData1EW = 0;
		if (g_pause_keyframe == FALSE) {
			/* Jn */
			for (i = 0; i < FILE_NUM; i++) {
				if (CPK_Pause(cpk[i], CPK_PAUSE_ON_KEYFRAME) == TRUE) {
					g_pause_keyframe = TRUE;
				}
			}
		} else {
			/*  */
			g_pause_keyframe = FALSE;
			for (i = 0; i < FILE_NUM; i++) {
				CPK_Pause(cpk[i], CPK_PAUSE_OFF);
			}
		}
	}

	/* Xgbv */
	if (CPK_GetPlayStatus(cpk[FILE_NUM - 2]) == CPK_STAT_PLAY_END) {
		if (PadData1EW & PER_DGT_A) {
			PadData1EW = 0;
			CPK_Stop(cpk[FILE_NUM - 1]);
		}
	}

	/* `FW */
	if ((g_change_flag == FALSE) && (PadData1EW & PER_DGT_A)) {
		PadData1EW = 0;
		g_change_flag = TRUE;
		goNextStm(stm[1]);
	}
	/* [r̋؂ւ */
	if (g_change_flag == TRUE) {
		if (CPK_CheckChange() == CPK_CHANGE_OK_AT_ONCE) {
			CPK_Change();
			g_change_flag = FALSE;
		}
	}

	/* {[EAbv */
	if (PadData1EW & PER_DGT_U) {
		PadData1EW = 0;
		g_level = MIN(g_level + 1, LEVEL_MAX);
		for (i = 0; i < FILE_NUM; i++) {
			CPK_SetVolume(cpk[i], g_level);
		}
	}
	/* {[E_E */
	if (PadData1EW & PER_DGT_D) {
		PadData1EW = 0;
		g_level = MAX(g_level - 1, LEVEL_MIN);
		for (i = 0; i < FILE_NUM; i++) {
			CPK_SetVolume(cpk[i], g_level);
		}
	}

	/* pEEiEőAXɎキj */
	if (PadData1EW & PER_DGT_R) {
		PadData1EW = 0;
		g_pan = MIN(g_pan + 1, PAN_MAX);
		for (i = 0; i < FILE_NUM; i++) {
			CPK_SetPan(cpk[i], g_pan_tbl[g_pan]);
		}
	}
	/* pEiőAEXɎキj */
	if (PadData1EW & PER_DGT_L) {
		PadData1EW = 0;
		g_pan = MAX(g_pan - 1, PAN_MIN);
		for (i = 0; i < FILE_NUM; i++) {
			CPK_SetPan(cpk[i], g_pan_tbl[g_pan]);
		}
	}
}

#define SMP_PAD_MODE_NUM		(1)
Sint32 smp_pad_mode = 0;

/* pbh */
void smp_PadCtrl(CpkHn cpk[], StmHn stm[])
{
	Uint16   PadData1EW;
	Uint16   PadData1W;

	PadData1EW = PadData1E;
	PadData1E = 0;
	PadData1W = PadData1;
	PadData1 = 0;

	/* pbhΏۂ̐؂ւ */
	if (PadData1EW & PER_DGT_TL) {
		PadData1EW = 0;
		smp_pad_mode++;
	}

	switch (smp_pad_mode % SMP_PAD_MODE_NUM) {
	case 0:
		/* pbhFĐCu */
		smp_PadCtrlCpk(cpk, stm, PadData1EW, PadData1W);
		break;
	}
}

void main(void)
{
	StmHn			stm[FILE_NUM];
	CpkHn			cpk[FILE_NUM];
	Uint32			restart;
	Sint32			is_keyframe;
	int				i;

#ifdef OUTPUT_WORK_RAM
	DMA_ScuInit();
#endif

	/* ϐ̏ */
	g_spr_end = FALSE;
	g_change_flag = FALSE;
	g_pause_at_once = FALSE;
	g_pause_keyframe = FALSE;

	/* XvCg̐ݒ */
	dispInit();

	/* t@C */
	fileInit();

	/* TEh̐ݒ */
	sndInit();

	/* VlpbN̏ */
	cpkInit();

	/* Xg[O[ṽI[v */
	grp_hd = STM_OpenGrp();
	if (grp_hd == NULL) {
		return;
	}
	STM_SetLoop(grp_hd, STM_LOOP_DFL, STM_LOOP_ENDLESS);
	STM_SetExecGrp(grp_hd);

	restart = 1;

	while (1) {
		if (restart) {

			for (i = 0; i < FILE_NUM; i++) {
				/* Xg[I[v */
				if ((stm[i] = stmOpen(filename[i])) == NULL) {
					return;
				}
				/* [rnh */
				if ((cpk[i] = createMovie(stm[i], i)) == NULL) {
					return;
				}
			}

			/* [rJn */
			CPK_Start(cpk[0]);

			/* ɍĐ郀[r̓o^ */
			CPK_EntryNext(cpk[1]);
			restart = 0;
		}

		/* [r̍Đ */
		CPK_Task(cpk[0]);
		CPK_Task(cpk[1]);

		is_keyframe = 0;

		for (i = 0; i < FILE_NUM; i++) {
			/* ʕ\ṽ`FbN */
			if (CPK_IsDispTime(cpk[i]) == TRUE) {

#ifdef OUTPUT_WORK_RAM
				DMA_ScuMemCopy((void *)ADDR_VRAM_CPK, 
					(void *)work_ram_buf, cp_size);
#endif

				/* \̒ʒm */
				CPK_CompleteDisp(cpk[i]);
			}
		}

		/* t[obt@̐؂ւƁA`I҂ */
		smp_DisplayFrameWait();

		/* pbh */
		smp_PadCtrl(cpk, stm);

		/* [ȑI */
		if (CPK_GetPlayStatus(cpk[FILE_NUM-1]) == CPK_STAT_PLAY_END) {

			/* ŏIt[\邽߂̑҂ */
			/* t[obt@̐؂ւ */
			SCL_DisplayFrame();

			for (i = 0; i < FILE_NUM; i++) {
				/* [r̕ */
				CPK_DestroyStmMovie(cpk[i]);

				/* Xg[̃N[Y*/
				stmClose(stm[i]);
			}

			restart = 1;
		}
	}
}
