/*******************************************************************
*
*                       Cinepak for SATURN Player 
*                                by SOJ
*                         usage sample program
*
*                 N}L[Đ̃Tv
*                 4000000hԒnɃ[h[r
*                 4400000hԒnɃ[h[rO
*
*                      Copyright(c) 1994,1995 SEGA
*
*   Comment: main module
*   File   : SMPCPK9.c
*   Date   : 1994-10-04
*   Author : Y.T
*
*******************************************************************/
#include <machine.h>
#include <string.h>
#define _SH
#include "sega_xpt.h"
#include "sega_sys.h"
#include "sega_def.h"
#include "sega_mth.h"
#include "sega_scl.h" 
#include "sega_int.h"
#define  _SPR2_
#include "sega_spr.h"
#include "sega_per.h"
#include "sega_snd.h"
#include "sega_cpk.h"


static void smpVblIn(void);
static void smpVblOut(void);
static void smpSprEnd(void);


/*------------------------- s}N萔t -------------------------*/

/* XvCgʂ̂uq`l̃AhX */
#define ADDR_VDP1 			(0x25C00000)

/* uq`l̓]̃AhX */
#define ADDR_VRAM 			((void *)0x25C08000)
#define ADDR_VRAM_CKEY 		((void *)0x25C2B000)

/* EF[uq`l̓]AhXƃTv */
#define PCM_ADDR			((void*)0x25a0c000)
#define PCM_SIZE			(4096L*14)
#define PCM_ADDR_CKEY		((void*)0x25a44000)
#define PCM_SIZE_CKEY		(4096L*14)

/* [Nobt@̃TCY */
#define WORK_BUF_SIZ		(1024L*1024L*16) 

/* suʃTCY */
#define DISP_XSIZE			(320)
#define DISP_YSIZE			(224)


/*----------------------- sO[oϐt -----------------------*/

/* [Nobt@ */
static Uint32 g_movie_work[CPK_24WORK_DSIZE];
static Uint32 g_movie_work_ckey[CPK_24WORK_DSIZE];

/* Oobt@ */
static Uint32 *g_movie_buf = (Uint32 *)0x04000000;
static Uint32 *g_movie_buf_ckey = (Uint32 *)0x04400000;

/* XvCg`ItO   TRUE : `I */
static volatile Bool g_spr_end;

/* pbh */
static Uint32	PadWorkArea[7];
static	Uint16	PadData1  = 0x0000;
static	Uint16	PadData1E = 0x0000;
static	Uint16	PadData2  = 0x0000;
static	Uint16	PadData2E = 0x0000;

/* L[AEg͈ */
Sint32 g_keyout_range;

static Uint32 g_vint_cnt;
static Uint32 g_vint_old;

/********************************************************************/
/* G[ɌĂ΂֐									*/
/********************************************************************/
void errGfsFunc(void *obj, Sint32 ec)
{
	/* G[ */
}

void errCpkFunc(void *obj, Sint32 errcode)
{
	/* G[ */
}


/*====================== t@C̏ ===========================*/

/* [gfBNgɂt@C̍ő吔 */
#define MAX_DIR		50

/* ɊJt@C̍ő吔 */
#define OPEN_MAX	5

/* fBNgǗ̈ */
static GfsDirTbl	dir_tbl;

/* t@C܂񂾏 */
static GfsDirName dir_name[MAX_DIR];

/* fer̍Ɨ̈ */
GfsMng g_gfs_work;
Uint8 g_gfs_work2[GFS_WORK_SIZE(OPEN_MAX)-sizeof(GfsMng)];

static void fileInit(void)
{
	Sint32 file_num;

	/* GFS̏ */
	GFS_DIRTBL_TYPE(&dir_tbl) = GFS_DIR_NAME;
	GFS_DIRTBL_DIRNAME(&dir_tbl) = dir_name;
	GFS_DIRTBL_NDIR(&dir_tbl) = MAX_DIR;

    /* t@CVXȅ */
    file_num = GFS_Init(OPEN_MAX, &g_gfs_work, &dir_tbl);
	if (file_num < 0) {
		return;
	}

	/* G[֐̐ݒ */
	GFS_SetErrFunc(errGfsFunc, NULL);
}


/*====================== ʕ\̏ ===========================*/
#define HENKEI_SPRITE		(4)

static SprSpCmd SpriteCmd[] = {
	{
		/* control  */ (JUMP_NEXT | FUNC_SCLIP),
		/* link     */  0,
		/* drawMode */  0,
		/* color    */  0,
		/* charAddr */  0,
		/* charSize */  0,
		/* ax, ay   */  0, 0,
		/* bx, by   */  0, 0,
		/* cx, cy   */  351, 223,
		/* dx, dy   */  0, 0,
		/* grshAddr */  0,
		/* dummy    */  0
	}, {
		/* control  */ (JUMP_NEXT | FUNC_LCOORD),
		/* link     */  0,
		/* drawMode */  0,
		/* color    */  0,
		/* charAddr */  0,
		/* charSize */  0,
		/* ax, ay   */  0, 0,
		/* bx, by   */  0, 0,
		/* cx, cy   */  0, 0,
		/* dx, dy   */  0, 0,
		/* grshAddr */  0,
		/* dummy    */  0
	}, {
		/* control  */ (JUMP_NEXT | FUNC_UCLIP),
		/* link     */  0,
		/* drawMode */  0,
		/* color    */  0,
		/* charAddr */  0,
		/* charSize */  0,
		/* ax, ay   */  0, 0,
		/* bx, by   */  0, 0,
		/* cx, cy   */  351, 223,
		/* dx, dy   */  0, 0,
		/* grshAddr */  0,
		/* dummy    */  0
   }, {
		/* control  */ 	(JUMP_NEXT | ZOOM_NOPOINT | DIR_NOREV | FUNC_POLYGON),
	    /* link     */  0,
	    /* drawMode */ (ECDSPD_DISABLE | COLOR_0 | COMPO_REP),
	    /* color    */  0,
	    /* charAddr */  0,
	    /* charSize */  0,
	    /* ax, ay   */  0, 0,
	    /* bx, by   */  DISP_XSIZE - 1, 0,
	    /* cx, cy   */  DISP_XSIZE - 1, DISP_YSIZE - 1,
	    /* dx, dy   */  0, DISP_YSIZE - 1,
	    /* grshAddr */  0,
	    /* dummy    */  0
	}, {
		/* control  */  (JUMP_NEXT | FUNC_DISTORSP),
		/* link     */  0,
		/* drawMode */  0x04E8,
		/* color    */  0x0000,		/*  */
		/* charAddr */  0x1000,
		/* charSize */  0x2098,
		/* ax, ay   */  0x0020,         0x0020,
		/* bx, by   */  0x0020 + 255,   0x0020,
		/* cx, cy   */  0x0020 + 255,   0x0020 + 151,
		/* dx, dy   */  0x0020,         0x0020 + 151,
		/* grshAddr */  0,
		/* dummy    */  0
	}, {
		/* control  */  (JUMP_NEXT | FUNC_DISTORSP),
		/* link     */  0,
		/* drawMode */  0x04A8,
		/* color    */  0x0000,		/*  */
		/* charAddr */  0x5600,
		/* charSize */  0x2098,
		/* ax, ay   */  0x0020,         0x0020,
		/* bx, by   */  0x0020 + 255,   0x0020,
		/* cx, cy   */  0x0020 + 255,   0x0020 + 151,
		/* dx, dy   */  0x0020,         0x0020 + 151,
		/* grshAddr */  0,
		/* dummy    */  0
	}, {
		/* [ 0]     */
		/* control  */ 	(CTRL_END),
		/* link     */ 	0,
		/* drawMode */ 	0,
		/* color    */ 	0,
		/* charAddr */ 	0,
		/* charSize */ 	0,
		/* ax, ay   */  0,   0,
		/* bx, by   */  0,   0,
		/* cx, cy   */  0,   0,
		/* dx, dy   */  0,   0,
		/* rshAddr */   0,
		/* dummy    */  0
	}, {
		/* [ 0]     */
		/* control  */ 	(CTRL_END),
		/* link     */ 	0,
		/* drawMode */ 	0,
		/* color    */ 	0,
		/* charAddr */ 	0,
		/* charSize */ 	0,
		/* ax, ay   */  0,   0,
		/* bx, by   */  0,   0,
		/* cx, cy   */  0,   0,
		/* dx, dy   */  0,   0,
		/* rshAddr */   0,
		/* dummy    */  0
	}
};

void eraseVram(void)
{
	Sint32 *addr = (Sint32 *)(0x25C80000);	/* end of VDP1 VRAM */

	do {
		*--addr = 0x80008000;
	} while ((Sint32)addr > 0x25C00000);	/* start of VDP1 VRAM */
}

static void dispInit(void)
{
    Uint8  *VRAM;
	Uint16			BackCol;

    set_imask(0);
    SCL_Vdp2Init();
    SCL_SetPriority(SCL_SP0|SCL_SP1|SCL_SP2|SCL_SP3|
                    SCL_SP4|SCL_SP5|SCL_SP6|SCL_SP7,7);
    SCL_SetSpriteMode(SCL_TYPE1,SCL_MIX,SCL_SP_WINDOW);

	/* uuN̐ݒ */
	INT_ChgMsk(INT_MSK_NULL, INT_MSK_VBLK_IN | INT_MSK_VBLK_OUT);

	/* V_Blank Out 荞݂҂ */
	(*((volatile Uint32 *)0x25fe00a4)) &= 0xfffffffc;	/* ܂NA */
	while( !((*((volatile Uint32 *)0x25fe00a4)) & 2) );
	PER_Init(PER_KD_PERTIM,2,PER_ID_DGT,PER_SIZE_DGT,PadWorkArea,0);

	INT_SetScuFunc(INT_SCU_VBLK_IN, smpVblIn);
	INT_SetScuFunc(INT_SCU_VBLK_OUT, smpVblOut);
	INT_ChgMsk(INT_MSK_VBLK_IN | INT_MSK_VBLK_OUT, INT_MSK_NULL);

	/* XvCg`I荞݂̐ݒ */
	INT_ChgMsk(INT_MSK_NULL,INT_MSK_SPR);
	INT_SetScuFunc(INT_SCU_SPR, smpSprEnd);
	INT_ChgMsk(INT_MSK_SPR, INT_MSK_NULL);

	BackCol = 0x0000;
	SCL_SetBack(SCL_VDP2_VRAM+0x80000-2,1,&BackCol);

    SPR_Initial(&VRAM);
    SPR_SetEraseData(RGB16_COLOR(0,0,0),0,0,DISP_XSIZE-1,DISP_YSIZE-1);
	SCL_SetFrameInterval(1);
	SCL_DisplayFrame();
	SCL_DisplayFrame();
	SCL_SetFrameInterval(-1);

	eraseVram();
}

static void setSprite(Uint32 command, Uint32 sizeX, Uint32 sizeY)
{
	Uint32 		luX, luY, rdX, rdY;

	SpriteCmd[command].charSize = (sizeX/8)<<8 | (sizeY - 1);
	luX = (320 - sizeX) / 2;
	luY = (224 - sizeY) / 2;
	rdX = luX + sizeX - 1;
	rdY = luY + sizeY - 1;
	SpriteCmd[command].ax = luX;
	SpriteCmd[command].ay = luY;
	SpriteCmd[command].bx = rdX;
	SpriteCmd[command].by = luY;
	SpriteCmd[command].cx = rdX;
	SpriteCmd[command].cy = rdY;
	SpriteCmd[command].dx = luX;
	SpriteCmd[command].dy = rdY;
	memcpy((void *)ADDR_VDP1, SpriteCmd, sizeof(SpriteCmd));

}


/*====================== uuN̏ ===========================*/
static void smpVblIn(void)
{
	/* b VblIn [`R[ */
	CPK_VblIn();

	/* OtBbNCugpׂɂ͎sȂ΂ȂȂ */
	SCL_VblankStart();

	g_vint_cnt++;
}

static void smpVblOut(void)
{
	PerDgtInfo	*pad;

	PER_GetPer((PerGetPer **)&pad);
	PadData1  = pad[0].data ^ 0xffff;
	PadData1E |= pad[0].push ^ 0xffff;
	PadData2  = pad[1].data ^ 0xffff;
	PadData2E |= pad[1].push ^ 0xffff;

	/* OtBbNCugpׂɂ͎sȂ΂ȂȂ */
	SCL_VblankEnd();
}

static void smpSprEnd(void)
{
	g_spr_end = TRUE;
}

/*====================== TEh̏ ===========================*/
#define SDDRVS_TSK_SIZE			(0x6000)
#define BOOTSND_MAP_SIZE		(0x0100)
Sint32 sddrvs_tsk[SDDRVS_TSK_SIZE / 4];
Sint32 bootsnd_map[BOOTSND_MAP_SIZE / 4];

static Sint32 fileLoad(Sint8 *name, void *addr, Sint32 bsize)
{
	Sint32 		fid, i;

	for (i = 0; i < 10; i++) {
		fid = GFS_NameToId(name);
		if (fid >= 0) {
			GFS_Load(fid, 0, addr, bsize);
			return 0;
		}
	}
	return -1;
}

static void sndInit(void)
{
	SndIniDt 	snd_init;

	if (fileLoad("SDDRVS.TSK", (void *)sddrvs_tsk, SDDRVS_TSK_SIZE)) {
		return;
	}
	if (fileLoad("BOOTSND.MAP", (void *)bootsnd_map, BOOTSND_MAP_SIZE)) {
		return;
	}
	SND_INI_PRG_ADR(snd_init) 	= (Uint16 *)sddrvs_tsk;
	SND_INI_PRG_SZ(snd_init) 	= (Uint16 )SDDRVS_TSK_SIZE;
	SND_INI_ARA_ADR(snd_init) 	= (Uint16 *)bootsnd_map;
	SND_INI_ARA_SZ(snd_init) 	= (Uint16)BOOTSND_MAP_SIZE;
	SND_Init(&snd_init);
	SND_ChgMap(0);
}


/* VlpbN̏ */
void cpkInit(void)
{
	/* VlpbN̏ */
	CPK_Init();

	/* G[֐̐ݒ */
	CPK_SetErrFunc(errCpkFunc, NULL);
}

/* [rnh */
void create_movie(CpkHn *cpk, Uint32 *g_movie_work, Uint32 *g_movie_buf)
{
	CpkHeader		*header;
	Uint32 			movie_x, movie_y;
	CpkCreatePara	para;

	/* [r */
	CPK_PARA_WORK_ADDR(&para) = g_movie_work;
	CPK_PARA_WORK_SIZE(&para) = CPK_24WORK_BSIZE;
	CPK_PARA_BUF_ADDR(&para) = g_movie_buf;
	CPK_PARA_BUF_SIZE(&para) = WORK_BUF_SIZ;
	CPK_PARA_PCM_ADDR(&para) = PCM_ADDR;
	CPK_PARA_PCM_SIZE(&para) = PCM_SIZE;

	*cpk = CPK_CreateMemMovie(&para);
	if (*cpk == NULL) {
		return;
	}

	/* \F̐ݒ */
	CPK_SetColor(*cpk, CPK_COLOR_15BIT);

	/* ̃[r̃t@CTCYݒ */
	CPK_NotifyWriteSize(*cpk, WORK_BUF_SIZ);

	/* [r̃TCY擾 */
	header = CPK_GetHeader(*cpk);
	movie_x = header->width;
	movie_y = header->height;
	setSprite(HENKEI_SPRITE, movie_x, movie_y);

	/* [r̕\AhXݒ */
	CPK_SetDecodeAddr(*cpk, ADDR_VRAM, 2 * movie_x);
	CPK_SetVolume(*cpk, 0);

}

void create_movie_ckey(CpkHn *cpk, Uint32 *g_movie_work, Uint32 *g_movie_buf)
{
	CpkHeader		*header;
	Uint32 			movie_x, movie_y;
	CpkCreatePara	para;

	/* [r */
	CPK_PARA_WORK_ADDR(&para) = g_movie_work;
	CPK_PARA_WORK_SIZE(&para) = CPK_24WORK_BSIZE;
	CPK_PARA_BUF_ADDR(&para) = g_movie_buf;
	CPK_PARA_BUF_SIZE(&para) = WORK_BUF_SIZ;
	CPK_PARA_PCM_ADDR(&para) = PCM_ADDR_CKEY;
	CPK_PARA_PCM_SIZE(&para) = PCM_SIZE_CKEY;

	*cpk = CPK_CreateMemMovie(&para);
	if (*cpk == NULL) {
		return;
	}

	/* \F̐ݒ */
	CPK_SetColor(*cpk, CPK_COLOR_15BIT);

	/* ̃[r̃t@CTCYݒ */
	CPK_NotifyWriteSize(*cpk, WORK_BUF_SIZ);

	/* [r̃TCY擾 */
	header = CPK_GetHeader(*cpk);
	movie_x = header->width;
	movie_y = header->height;
	setSprite(HENKEI_SPRITE + 1, movie_x, movie_y);

	/* [r̕\AhXݒ */
	CPK_SetDecodeAddr(*cpk, ADDR_VRAM_CKEY, 2 * movie_x);

	CPK_SetPcmStreamNo(*cpk, 1);
/*	CPK_SetPcmCmdBlockNo(*cpk, 1); */
/*	CPK_SetVolume(*cpk, 0); */
}

static void setKeyOutRange(CpkHn cpk)
{
	Uint16   PadData1EW;

	PadData1EW = PadData1;
	PadData1E = 0;

	if (g_vint_cnt - g_vint_old <= 3) {
		return;
	}
	g_vint_old = g_vint_cnt;

	/* L[AEg͈͂̕ύX */
	if (PadData1EW & PER_DGT_U) {
		PadData1EW = 0;
		/* ₷ */
		g_keyout_range++;
		if (g_keyout_range > 96) {
			g_keyout_range = 96;
		}
		CPK_SetKeyOutRange(cpk, g_keyout_range);
	} else if (PadData1EW & PER_DGT_D) {
		PadData1EW = 0;
		/* 炷 */
		g_keyout_range--;
		if (g_keyout_range < 0) {
			g_keyout_range = 0;
		}
		CPK_SetKeyOutRange(cpk, g_keyout_range);
	}
}

void main(void)
{
	CpkHn 			cpk1, cpk_ckey;
	Uint32			create_movie_flag;
	Uint32			create_movie_ckey_flag;

	/* ϐ̏ */
	g_spr_end = FALSE;
	g_keyout_range = 21;
	g_vint_cnt = 0;
	g_vint_old = 0;
	create_movie_flag = 1;
	create_movie_ckey_flag = 1;

	/* XvCg̐ݒ */
	dispInit();

	/* t@C */
	fileInit();

	/* TEh̐ݒ */
	sndInit();

	/* VlpbN̏ */
	cpkInit();

	while (1) {
		if (create_movie_flag) {
			create_movie(&cpk1, g_movie_work, g_movie_buf);
			CPK_Start(cpk1);
			create_movie_flag = 0;
		}
		if (create_movie_ckey_flag) {
			create_movie_ckey(&cpk_ckey, g_movie_work_ckey, g_movie_buf_ckey);
			/* L[AEg͈͂̐ݒ */
			CPK_SetKeyOutRange(cpk_ckey, g_keyout_range);
			CPK_Start(cpk_ckey);
			create_movie_ckey_flag = 0;
		}

		/* [r̍Đ */
		CPK_Task(cpk1);
		CPK_Task(cpk_ckey);

		setKeyOutRange(cpk_ckey);

		/* ʕ\ṽ`FbN */
		if (CPK_IsDispTime(cpk1) == TRUE) {
			/* t[؂ւ */
			SCL_DisplayFrame();
			/* uq`lt[obt@ւ̕`I҂ */
			g_spr_end = FALSE;
			while (g_spr_end == FALSE) ;
			CPK_CompleteDisp(cpk1);
		}
		if (CPK_IsDispTime(cpk_ckey) == TRUE) {
			CPK_CompleteDisp(cpk_ckey);
		}

		/* [ȑI */
		if (CPK_GetPlayStatus(cpk1) == CPK_STAT_PLAY_END) {
			CPK_DestroyMemMovie(cpk1);
			create_movie_flag = 1;
		}
		if (CPK_GetPlayStatus(cpk_ckey) == CPK_STAT_PLAY_END) {
			CPK_DestroyMemMovie(cpk_ckey);
			create_movie_ckey_flag = 1;
		}
	}
}
